# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ......core.datetime_utils import serialize_datetime
from .....commons.types.insurance_type_code import InsuranceTypeCode
from .line_of_business import LineOfBusiness


class InsuranceType(pydantic.BaseModel):
    line_of_business: LineOfBusiness = pydantic.Field(
        description="The line of business associated with the patient’s insurance"
    )
    insurance_type_codes: typing.List[InsuranceTypeCode] = pydantic.Field(
        description="The Insurance Type Code associated with the patient’s insurance plan."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
